// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:msg/RouterStatus.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'missing_robots'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/RouterStatus in the package tuw_multi_robot_msgs.
/**
  * A message to publish the status of the last route
  * generation
 */
typedef struct tuw_multi_robot_msgs__msg__RouterStatus
{
  /// the unique id of the new plan
  int32_t id;
  /// true if a routing table was found to the given scenario
  bool success;
  /// if the plan fails because of absent robots, these robots are listed here
  rosidl_runtime_c__String__Sequence missing_robots;
  /// the time until a routing table was found
  int32_t duration;
  /// the overall path length in the routing table (calculated using weights)
  int32_t overall_path_length;
  /// the longest path length in a routing table (calculated using weights)
  int32_t longest_path_length;
  /// shows how often robot priorities are exchanged
  int32_t priority_scheduling_attemps;
  /// shows how many robots speed was reduced during planning
  int32_t speed_scheduling_attemps;
} tuw_multi_robot_msgs__msg__RouterStatus;

// Struct for a sequence of tuw_multi_robot_msgs__msg__RouterStatus.
typedef struct tuw_multi_robot_msgs__msg__RouterStatus__Sequence
{
  tuw_multi_robot_msgs__msg__RouterStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__msg__RouterStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_H_
