// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:srv/StationManagerControlProtocol.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StationManagerControlProtocol_Request_
{
  using Type = StationManagerControlProtocol_Request_<ContainerAllocator>;

  explicit StationManagerControlProtocol_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->request = "";
      this->addition = "";
    }
  }

  explicit StationManagerControlProtocol_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : request(_alloc),
    addition(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->request = "";
      this->addition = "";
    }
  }

  // field types and members
  using _request_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _request_type request;
  using _addition_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _addition_type addition;

  // setters for named parameter idiom
  Type & set__request(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__addition(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->addition = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> LOAD;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SAVE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> UPDATE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ONCE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> CHANGE;

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StationManagerControlProtocol_Request_ & other) const
  {
    if (this->request != other.request) {
      return false;
    }
    if (this->addition != other.addition) {
      return false;
    }
    return true;
  }
  bool operator!=(const StationManagerControlProtocol_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StationManagerControlProtocol_Request_

// alias to use template instance with default allocator
using StationManagerControlProtocol_Request =
  tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Request_<ContainerAllocator>::LOAD = "load";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Request_<ContainerAllocator>::SAVE = "save";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Request_<ContainerAllocator>::UPDATE = "update";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Request_<ContainerAllocator>::ONCE = "once";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Request_<ContainerAllocator>::CHANGE = "change";

}  // namespace srv

}  // namespace tuw_multi_robot_msgs


#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StationManagerControlProtocol_Response_
{
  using Type = StationManagerControlProtocol_Response_<ContainerAllocator>;

  explicit StationManagerControlProtocol_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->response = "";
    }
  }

  explicit StationManagerControlProtocol_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : response(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->response = "";
    }
  }

  // field types and members
  using _response_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__response(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> EXECUTED;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FAILED;
  // guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ERROR;
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response
    std::shared_ptr<tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StationManagerControlProtocol_Response_ & other) const
  {
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const StationManagerControlProtocol_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StationManagerControlProtocol_Response_

// alias to use template instance with default allocator
using StationManagerControlProtocol_Response =
  tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Response_<ContainerAllocator>::EXECUTED = "executed";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Response_<ContainerAllocator>::FAILED = "failed";
// guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
StationManagerControlProtocol_Response_<ContainerAllocator>::ERROR = "error";
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif

}  // namespace srv

}  // namespace tuw_multi_robot_msgs

namespace tuw_multi_robot_msgs
{

namespace srv
{

struct StationManagerControlProtocol
{
  using Request = tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Request;
  using Response = tuw_multi_robot_msgs::srv::StationManagerControlProtocol_Response;
};

}  // namespace srv

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_HPP_
